﻿-- Addon: QTR_Quests (version: 2.15.1) 2021.06.13
-- Description: AddOn displays the translated quest informations in other language independent of realm language.
-- Author: Platine  (e-mail: platine.wow@gmail.com)
-- Addon project page: https://panel.wowpopolsku.pl/qtr-quests.php

-- Zmienne lokalne
local QTR_version = GetAddOnMetadata("QTR_Quests", "Version");
local QTR_locale = GetLocale();
local QTR_name = UnitName("player");
local QTR_sex  = UnitSex("player");
local QTR_class= UnitClass("player");
local QTR_race = UnitRace("player");
local QTR_waitTable = {};
local QTR_waitFrame = nil;
local QTR_MessOrig = {
      details    = QUEST_DESCRIPTION, 
      objectives = QUEST_OBJECTIVES, 
      rewards    = QUEST_REWARDS, 
      itemchoose0= REWARD_ITEMS_ONLY,
      itemchoose1= REWARD_CHOICES, 
      itemchoose2= REWARD_CHOOSE, 
      itemchoose3= "You receiving the reward:",
      itemreceiv0= REWARD_ITEMS_ONLY,
      itemreceiv1= REWARD_ITEMS, 
      itemreceiv2= "You receiving the reward:", 
      itemreceiv3= "You also receiving the reward:",
      learnspell = LEARN_SPELL_OBJECTIVE, 
      reqmoney   = REQUIRED_MONEY, 
      reqitems   = TURN_IN_ITEMS, 
      experience = EXPERIENCE_COLON, 
      currquests = CURRENT_QUESTS, 
      avaiquests = AVAILABLE_QUESTS, 
      reward_aura      = REWARD_AURA, 
      reward_spell     = REWARD_SPELL, 
      reward_companion = REWARD_COMPANION, 
      reward_follower  = REWARD_FOLLOWER, 
      reward_reputation= REWARD_REPUTATION_TEXT, 
      reward_title     = REWARD_TITLE, 
      reward_tradeskill= REWARD_TRADESKILL_SPELL, 
      reward_unlock    = REWARD_UNLOCK, 
      reward_bonus     = REWARD_BONUS };
local QTR_quest_ID = 0;      
local QTR_quest_EN = { };      
local QTR_quest_LG = { };      
      QTR_quest_EN[0] = { };
      QTR_quest_LG[0] = { };
local quest_numReward = {};       -- liczba dostępnych nagród do questu
local last_time = GetTime();
local last_text = 0;
local curr_trans = "1";
local Original_Font1;
local Original_Font2;
local p_race = {
      [1] = { enUS = "Blood Elf", deDE2="Blutelf", deDE3="Blutelfe", frFR2="Elfe de sang", frFR3="Elfe de sang", esES2="Elfo de sangre", esES3="Elfa de sangre", itIT2="Elfo del Sangue", itIT3="Elfa del Sangue", ptBR2="Elfo Sangrento", ptBR3IT="Elfa Sangrenta", ruRU2="Эльф крови", ruRU3="Эльфийка крови" }, 
      [2] = { enUS = "Dark Iron Dwarf", deDE2="", deDE3="", frFR2="", frFR3="", esES2="", esES3="", itIT2="", itIT3="", ptBR2="", ptBR3IT="", ruRU2="", ruRU3="" },
      [3] = { enUS = "Draenei", deDE2="Draenei", deDE3="Draenei", frFR2="Draenei", frFR3="Draenei", esES2="Draenei", esES3="Draenei", itIT2="Draenei", itIT3="Draenei", ptBR2="Draenei", ptBR3IT="Draeneia", ruRU2="Дреней", ruRU3="Дренейка" },
      [4] = { enUS = "Dwarf", deDE2="Zwerg", deDE3="Zwergin", frFR2="Nain", frFR3="Naine", esES2="Enano", esES3="Enana", itIT2="Nano", itIT3="Nana", ptBR2="Anão", ptBR3IT="Anã", ruRU2="Дворф", ruRU3="Дворфийка" },
      [5] = { enUS = "Gnome", deDE2="Gnom", deDE3="Gnom", frFR2="Gnome", frFR3="Gnome", esES2="Gnomo", esES3="Gnoma", itIT2="Gnomo", itIT3="Gnoma", ptBR2="Gnomo", ptBR3IT="Gnomida", ruRU2="Гном", ruRU3="Гномка" },
      [6] = { enUS = "Goblin", deDE2="Goblin", deDE3="Goblin", frFR2="Gobelin", frFR3="Gobeline", esES2="Goblin", esES3="Goblin", itIT2="Goblin", itIT3="Goblin", ptBR2="Goblin", ptBR3IT="Goblina", ruRU2="Гоблин", ruRU3="Гоблин" },
      [7] = { enUS = "Highmountain Tauren", deDE2="", deDE3="", frFR2="", frFR3="", esES2="", esES3="", itIT2="", itIT3="", ptBR2="", ptBR3IT="", ruRU2="", ruRU3="" },
      [8] = { enUS = "Human", deDE2="Mensch", deDE3="Mensch", frFR2="Humain", frFR3="Humaine", esES2="Humano", esES3="Humana", itIT2="Omano", itIT3="Umana", ptBR2="Humano", ptBR3IT="Humana", ruRU2="Человек", ruRU3="Человек" },
      [9] = { enUS = "Kul Tiran Human", deDE2="", deDE3="", frFR2="", frFR3="", esES2="", esES3="", itIT2="", itIT3="", ptBR2="", ptBR3IT="", ruRU2="", ruRU3="" },
      [10] = { enUS = "Lightforged Draenei", deDE2="", deDE3="", frFR2="", frFR3="", esES2="", esES3="", itIT2="", itIT3="", ptBR2="", ptBR3IT="", ruRU2="", ruRU3="" },
      [11] = { enUS = "Mag'har Orc", deDE2="", deDE3="", frFR2="", frFR3="", esES2="", esES3="", itIT2="", itIT3="", ptBR2="", ptBR3IT="", ruRU2="", ruRU3="" },
      [12] = { enUS = "Nightborne", deDE2="", deDE3="", frFR2="", frFR3="", esES2="", esES3="", itIT2="", itIT3="", ptBR2="", ptBR3IT="", ruRU2="", ruRU3="" },
      [13] = { enUS = "Night Elf", deDE2="Nachtelf", deDE3="Nachtelfe", frFR2="Elfe de la nuit", frFR3="Elfe de la nuit", esES2="Elfo de la noche", esES3="Elfa de la noche", itIT2="Elfo della Notte", itIT3="Elfa della Notte", ptBR2="Elfo Noturno", ptBR3IT="Elfa Noturna", ruRU2="Ночной эльф", ruRU3="Ночная эльфийка" },
      [14] = { enUS = "Orc", deDE2="Orc", deDE3="Orc", frFR2="Orc", frFR3="Orque", esES2="Orco", esES3="Orco", itIT2="Orco", itIT3="Orchessa", ptBR2="Orc", ptBR3IT="Orquisa", ruRU2="Орк", ruRU3="Орчиха" },
      [15] = { enUS = "Pandaren", deDE2="Pandaren", deDE3="Pandaren", frFR2="Pandaren", frFR3="Pandarène", esES2="Pandaren", esES3="Pandaren", itIT2="Pandaren", itIT3="Pandaren", ptBR2="Pandaren", ptBR3IT="Pandarena", ruRU2="", ruRU3="" },
      [16] = { enUS = "Tauren", deDE2="Tauren", deDE3="Tauren", frFR2="Tauren", frFR3="Taurène", esES2="Tauren", esES3="Tauren", itIT2="Tauren", itIT3="Tauren", ptBR2="Tauren", ptBR3IT="Taurena", ruRU2="Таурен", ruRU3="Тауренка" },
      [17] = { enUS = "Troll", deDE2="Troll", deDE3="Troll", frFR2="Troll", frFR3="Trollesse", esES2="Trol", esES3="Trol", itIT2="Troll", itIT3="Troll", ptBR2="Troll", ptBR3IT="Trolesa", ruRU2="Тролль", ruRU3="Тролль" },
      [18] = { enUS = "Undead", deDE2="Untoter", deDE3="Untote", frFR2="Mort-vivant", frFR3="Moort-vivante", esES2="No-muerto", esES3="No-muerta", itIT2="Non Morto", itIT3="Non Morta", ptBR2="Morto-vivo", ptBR3IT="Morto-viva", ruRU2="Нежить", ruRU3="Нежить" },
      [19] = { enUS = "Void Elf", deDE2="", deDE3="", frFR2="", frFR3="", esES2="", esES3="", itIT2="", itIT3="", ptBR2="", ptBR3IT="", ruRU2="", ruRU3="" },
      [20] = { enUS = "Worgen", deDE2="Worgen", deDE3="Wergen", frFR2="Worgen", frFR3="Worgen", esES2="Huargen", esES3="Huargen", itIT2="Worgen", itIT3="Worgen", ptBR2="Worgen", ptBR3IT="Worgerin", ruRU2="Ворген", ruRU3="Ворген" },
      [21] = { enUS = "Zandalari Troll", deDE2="", deDE3="", frFR2="", frFR3="", esES2="", esES3="", itIT2="", itIT3="", ptBR2="", ptBR3IT="", ruRU2="", ruRU3="" } }
local p_class = {
      [1] = { enUS = "Death Knight", deDE2="Todesrichter", deDE3="Todesrichter", frFR2="Chavalier de la mort", frFR3="Chavalier de la mort", esES2="Caballero de la Muerte", esES3="Caballero de la Muerte", itIT2="Cavaliere della Morte", itIT3="Cavaliere della Morte", ptBR2="Cavaliero da Morte", ptBR3IT="Cavaleira da Morte", ruRU2="Рыцарь смерти", ruRU3="Рыцарь смерти" },
      [2] = { enUS = "Demon Hunter", deDE2="", deDE3="", frFR2="", frFR3="", esES2="", esES3="", itIT2="", itIT3="", ptBR2="", ptBR3IT="", ruRU2="Охотник на демонов", ruRU3="Охотница на демонов" },
      [3] = { enUS = "Druid", deDE2="Druide", deDE3="Druidin", frFR2="Druide", frFR3="Druidesse", esES2="Druido", esES3="Driuda", itIT2="Druido", itIT3="Druida", ptBR2="Druida", ptBR3IT="Druidesa", ruRU2="Друид", ruRU3="Друид" },
      [4] = { enUS = "Hunte", deDE2="Jäger", deDE3="Jägerin", frFR2="Chasseur", frFR3="Chasseresse", esES2="Cazador", esES3="Cazadora", itIT2="Cacciotore", itIT3="Cacciotrice", ptBR2="Caçador", ptBR3IT="Caçadora", ruRU2="Охотник", ruRU3="Охотница" },
      [5] = { enUS = "Mage", deDE2="Magier", deDE3="Magierin", frFR2="Mage", frFR3="Mage", esES2="Mago", esES3="Maga", itIT2="Mago", itIT3="Maga", ptBR2="Mago", ptBR3IT="Maga", ruRU2="Маг", ruRU3="Маг" },
      [6] = { enUS = "Monk", deDE2="Mönch", deDE3="Mönch", frFR2="Moine", frFR3="Moniale", esES2="Monje", esES3="Monje", itIT2="Monaco", itIT3="Monaca", ptBR2="Monge", ptBR3IT="Monja", ruRU2="Монах", ruRU3="Монахиня" },
      [7] = { enUS = "Paladin", deDE2="Paladin", deDE3="Paladin", frFR2="Paladin", frFR3="Paladin", esES2="Paladin", esES3="Paladin", itIT2="Paladino", itIT3="Paladina", ptBR2="Paladino", ptBR3IT="Paladina", ruRU2="Паладин", ruRU3="Паладин" },
      [8] = { enUS = "Priest", deDE2="Priester", deDE3="Priesterin", frFR2="Prêtre", frFR3="Prêtresse", esES2="Sacerdote", esES3="Sacerdotisa", itIT2="Sacerdote", itIT3="Sacerdotessa", ptBR2="Sacerdote", ptBR3IT="Sacerdotisa", ruRU2="Жрец", ruRU3="Жрица" },
      [9] = { enUS = "Rogue", deDE2="Schurke", deDE3="Schurin", frFR2="Voleur", frFR3="Voleuse", esES2="Picaro", esES3="Picara", itIT2="Ladro", itIT3="Ladra", ptBR2="Ladino", ptBR3IT="Ladina", ruRU2="Разгойник", ruRU3="Разгойница" },
      [10] = { enUS = "Shaman", deDE2="Schamane", deDE3="Schamanin", frFR2="Chaman", frFR3="Chamane", esES2="Chamán", esES3="Chamán", itIT2="Sciamano", itIT3="Sciamana", ptBR2="Xamã", ptBR3IT="Xamã", ruRU2="Шаман", ruRU3="Шаманка" },
      [11] = { enUS = "Warlock", deDE2="Hexenmaister", deDE3="Hexenmaisterin", frFR2="Démoniste", frFR3="Démoniste", esES2="Brujo", esES3="Bruja", itIT2="Stregone", itIT3="Strega", ptBR2="Bruxo", ptBR3IT="Bruxa", ruRU2="Чернокнижник", ruRU3="Чернокнижница" },
      [12] = { enUS = "Warrior", deDE2="Krieger", deDE3="Kriegerin", frFR2="Guerrier", frFR3="Guerrière", esES2="Guerrero", esES3="Guerrera", itIT2="Guerrino", itIT3="Guerrina", ptBR2="Guerreito", ptBR3IT="Guerreita", ruRU2="Воин", ruRU3="Воин" } }

if (QTR_locale=="enUS") then
   if (QTR_sex==2) then     -- Male
      for i=1,21 do
         if (p_race[i].enUS == QTR_race) then
            if (QTR_lang=="RU") then
               player_race = p_race[i].ruRU2;
            elseif (QTR_lang=="DE") then
               player_race = p_race[i].deDE2;
            elseif (QTR_lang=="FR") then
               player_race = p_race[i].frFR2;
            elseif (QTR_lang=="ES") then
               player_race = p_race[i].esES2;
            elseif (QTR_lang=="IT") then
               player_race = p_race[i].itIT2;
            elseif (QTR_lang=="PT") then
               player_race = p_race[i].ptBR2;
            else
               player_race = p_race[i].enUS;
            end
            break;
         end
      end
      for i=1,12 do
         if (p_class[i].enUS == QTR_class) then
            if (QTR_lang=="RU") then
               player_class = p_class[i].ruRU2;
            elseif (QTR_lang=="DE") then
               player_class = p_class[i].deDE2;
            elseif (QTR_lang=="FR") then
               player_class = p_class[i].frFR2;
            elseif (QTR_lang=="ES") then
               player_class = p_class[i].esES2;
            elseif (QTR_lang=="IT") then
               player_class = p_class[i].itIT2;
            elseif (QTR_lang=="PT") then
               player_class = p_class[i].ptBR2;
            else
               player_class = p_class[i].enUS;
            end
            break;
         end
      end
   else              -- Female
      for i=1,21 do
         if (p_race[i].enUS == QTR_race) then
            if (QTR_lang=="RU") then
               player_race = p_race[i].ruRU3;
            elseif (QTR_lang=="DE") then
               player_race = p_race[i].deDE3;
            elseif (QTR_lang=="FR") then
               player_race = p_race[i].frFR3;
            elseif (QTR_lang=="ES") then
               player_race = p_race[i].esES3;
            elseif (QTR_lang=="IT") then
               player_race = p_race[i].itIT3;
            elseif (QTR_lang=="PT") then
               player_race = p_race[i].ptBR3;
            else
               player_race = p_race[i].enUS;
            end
            break;
         end
      end
      for i=1,12 do
         if (p_class[i].enUS == QTR_class) then
            if (QTR_lang=="RU") then
               player_class = p_class[i].ruRU3;
            elseif (QTR_lang=="DE") then
               player_class = p_class[i].deDE3;
            elseif (QTR_lang=="FR") then
               player_class = p_class[i].frFR3;
            elseif (QTR_lang=="ES") then
               player_class = p_class[i].esES3;
            elseif (QTR_lang=="IT") then
               player_class = p_class[i].itIT3;
            elseif (QTR_lang=="PT") then
               player_class = p_class[i].ptBR3;
            else
               player_class = p_class[i].enUS;
            end
            break;
         end
      end
   end
elseif (QTR_locale=="deDE") then
   if (QTR_sex==2) then      -- Male
      for i=1,21 do
         if (p_race[i].deDE2 == QTR_race) then
            if (QTR_lang=="RU") then
               player_race = p_race[i].ruRU2;
            elseif (QTR_lang=="EN") then
               player_race = p_race[i].enUS;
            elseif (QTR_lang=="FR") then
               player_race = p_race[i].frFR2;
            elseif (QTR_lang=="ES") then
               player_race = p_race[i].esES2;
            elseif (QTR_lang=="IT") then
               player_race = p_race[i].itIT2;
            elseif (QTR_lang=="PT") then
               player_race = p_race[i].ptBR2;
            else
               player_race = p_race[i].deDE2;
            end
            break;
         end
      end
      for i=1,12 do
         if (p_class[i].deDE2 == QTR_class) then
            if (QTR_lang=="RU") then
               player_class = p_class[i].ruRU2;
            elseif (QTR_lang=="EN") then
               player_class = p_class[i].enUS;
            elseif (QTR_lang=="FR") then
               player_class = p_class[i].frFR2;
            elseif (QTR_lang=="ES") then
               player_class = p_class[i].esES2;
            elseif (QTR_lang=="IT") then
               player_class = p_class[i].itIT2;
            elseif (QTR_lang=="PT") then
               player_class = p_class[i].ptBR2;
            else
               player_class = p_class[i].deDE2;
            end
            break;
         end
      end
   else              -- Female
      for i=1,21 do
         if (p_race[i].deDE3 == QTR_race) then
            if (QTR_lang=="RU") then
               player_race = p_race[i].ruRU3;
            elseif (QTR_lang=="EN") then
               player_race = p_race[i].enUS;
            elseif (QTR_lang=="FR") then
               player_race = p_race[i].frFR3;
            elseif (QTR_lang=="ES") then
               player_race = p_race[i].esES3;
            elseif (QTR_lang=="IT") then
               player_race = p_race[i].itIT3;
            elseif (QTR_lang=="PT") then
               player_race = p_race[i].ptBR3;
            else
               player_race = p_race[i].deDE3;
            end
            break;
         end
      end
      for i=1,12 do
         if (p_class[i].deDE3 == QTR_class) then
            if (QTR_lang=="RU") then
               player_class = p_class[i].ruRU3;
            elseif (QTR_lang=="EN") then
               player_class = p_class[i].enUS;
            elseif (QTR_lang=="FR") then
               player_class = p_class[i].frFR3;
            elseif (QTR_lang=="ES") then
               player_class = p_class[i].esES3;
            elseif (QTR_lang=="IT") then
               player_class = p_class[i].itIT3;
            elseif (QTR_lang=="PT") then
               player_class = p_class[i].ptBR3;
            else
               player_class = p_class[i].deDE3;
            end
            break;
         end
      end
   end
elseif (QTR_locale=="frFR") then
   if (QTR_sex==2) then      -- Male
      for i=1,21 do
         if (p_race[i].frFR2 == QTR_race) then
            if (QTR_lang=="RU") then
               player_race = p_race[i].ruRU2;
            elseif (QTR_lang=="EN") then
               player_race = p_race[i].enUS;
            elseif (QTR_lang=="DE") then
               player_race = p_race[i].deDE2;
            elseif (QTR_lang=="ES") then
               player_race = p_race[i].esES2;
            elseif (QTR_lang=="IT") then
               player_race = p_race[i].itIT2;
            elseif (QTR_lang=="PT") then
               player_race = p_race[i].ptBR2;
            else
               player_race = p_race[i].frFR2;
            end
            break;
         end
      end
      for i=1,12 do
         if (p_class[i].frFR2 == QTR_class) then
            if (QTR_lang=="RU") then
               player_class = p_class[i].ruRU2;
            elseif (QTR_lang=="EN") then
               player_class = p_class[i].enUS;
            elseif (QTR_lang=="DE") then
               player_class = p_class[i].deDE2;
            elseif (QTR_lang=="ES") then
               player_class = p_class[i].esES2;
            elseif (QTR_lang=="IT") then
               player_class = p_class[i].itIT2;
            elseif (QTR_lang=="PT") then
               player_class = p_class[i].ptBR2;
            else
               player_class = p_class[i].frFR2;
            end
            break;
         end
      end
   else              -- Female
      for i=1,21 do
         if (p_race[i].frFR3 == QTR_race) then
            if (QTR_lang=="RU") then
               player_race = p_race[i].ruRU3;
            elseif (QTR_lang=="EN") then
               player_race = p_race[i].enUS;
            elseif (QTR_lang=="DE") then
               player_race = p_race[i].deDE3;
            elseif (QTR_lang=="ES") then
               player_race = p_race[i].esES3;
            elseif (QTR_lang=="IT") then
               player_race = p_race[i].itIT3;
            elseif (QTR_lang=="PT") then
               player_race = p_race[i].ptBR3;
            else
               player_race = p_race[i].frFR3;
            end
            break;
         end
      end
      for i=1,12 do
         if (p_class[i].frFR3 == QTR_class) then
            if (QTR_lang=="RU") then
               player_class = p_class[i].ruRU3;
            elseif (QTR_lang=="EN") then
               player_class = p_class[i].enUS;
            elseif (QTR_lang=="DE") then
               player_class = p_class[i].deDE3;
            elseif (QTR_lang=="ES") then
               player_class = p_class[i].esES3;
            elseif (QTR_lang=="IT") then
               player_class = p_class[i].itIT3;
            elseif (QTR_lang=="PT") then
               player_class = p_class[i].ptBR3;
            else
               player_class = p_class[i].frFR3;
            end
            break;
         end
      end
   end
elseif (QTR_locale=="esES") then
   if (QTR_sex==2) then      -- Male
      for i=1,21 do
         if (p_race[i].esES2 == QTR_race) then
            if (QTR_lang=="RU") then
               player_race = p_race[i].ruRU2;
            elseif (QTR_lang=="EN") then
               player_race = p_race[i].enUS;
            elseif (QTR_lang=="DE") then
               player_race = p_race[i].deDE2;
            elseif (QTR_lang=="FR") then
               player_race = p_race[i].frFR2;
            elseif (QTR_lang=="IT") then
               player_race = p_race[i].itIT2;
            elseif (QTR_lang=="PT") then
               player_race = p_race[i].ptBR2;
            else
               player_race = p_race[i].esES2;
            end
            break;
         end
      end
      for i=1,12 do
         if (p_class[i].esES2 == QTR_class) then
            if (QTR_lang=="RU") then
               player_class = p_class[i].ruRU2;
            elseif (QTR_lang=="EN") then
               player_class = p_class[i].enUS;
            elseif (QTR_lang=="DE") then
               player_class = p_class[i].deDE2;
            elseif (QTR_lang=="FR") then
               player_class = p_class[i].frFR2;
            elseif (QTR_lang=="IT") then
               player_class = p_class[i].itIT2;
            elseif (QTR_lang=="PT") then
               player_class = p_class[i].ptBR2;
            else
               player_class = p_class[i].esES2;
            end
            break;
         end
      end
   else              -- Female
      for i=1,21 do
         if (p_race[i].esES3 == QTR_race) then
            if (QTR_lang=="RU") then
               player_race = p_race[i].ruRU3;
            elseif (QTR_lang=="EN") then
               player_race = p_race[i].enUS;
            elseif (QTR_lang=="DE") then
               player_race = p_race[i].deDE3;
            elseif (QTR_lang=="FR") then
               player_race = p_race[i].frFR3;
            elseif (QTR_lang=="IT") then
               player_race = p_race[i].itIT3;
            elseif (QTR_lang=="PT") then
               player_race = p_race[i].ptBR3;
            else
               player_race = p_race[i].esES3;
            end
            break;
         end
      end
      for i=1,12 do
         if (p_class[i].esES3 == QTR_class) then
            if (QTR_lang=="RU") then
               player_class = p_class[i].ruRU3;
            elseif (QTR_lang=="EN") then
               player_class = p_class[i].enUS;
            elseif (QTR_lang=="DE") then
               player_class = p_class[i].deDE3;
            elseif (QTR_lang=="FR") then
               player_class = p_class[i].frFR3;
            elseif (QTR_lang=="IT") then
               player_class = p_class[i].itIT3;
            elseif (QTR_lang=="PT") then
               player_class = p_class[i].ptBR3;
            else
               player_class = p_class[i].esES3;
            end
            break;
         end
      end
   end
elseif (QTR_locale=="itIT") then
   if (QTR_sex==2) then      -- Male
      for i=1,21 do
         if (p_race[i].itIT2 == QTR_race) then
            if (QTR_lang=="RU") then
               player_race = p_race[i].ruRU2;
            elseif (QTR_lang=="EN") then
               player_race = p_race[i].enUS;
            elseif (QTR_lang=="DE") then
               player_race = p_race[i].deDE2;
            elseif (QTR_lang=="FR") then
               player_race = p_race[i].frFR2;
            elseif (QTR_lang=="ES") then
               player_race = p_race[i].esES2;
            elseif (QTR_lang=="PT") then
               player_race = p_race[i].ptBR2;
            else
               player_race = p_race[i].itIT2;
            end
            break;
         end
      end
      for i=1,12 do
         if (p_class[i].itIT2 == QTR_class) then
            if (QTR_lang=="RU") then
               player_class = p_class[i].ruRU2;
            elseif (QTR_lang=="EN") then
               player_class = p_class[i].enUS;
            elseif (QTR_lang=="DE") then
               player_class = p_class[i].deDE2;
            elseif (QTR_lang=="FR") then
               player_class = p_class[i].frFR2;
            elseif (QTR_lang=="ES") then
               player_class = p_class[i].esES2;
            elseif (QTR_lang=="PT") then
               player_class = p_class[i].ptBR2;
            else
               player_class = p_class[i].itIT2;
            end
            break;
         end
      end
   else              -- Female
      for i=1,21 do
         if (p_race[i].itIT3 == QTR_race) then
            if (QTR_lang=="RU") then
               player_race = p_race[i].ruRU3;
            elseif (QTR_lang=="EN") then
               player_race = p_race[i].enUS;
            elseif (QTR_lang=="DE") then
               player_race = p_race[i].deDE3;
            elseif (QTR_lang=="FR") then
               player_race = p_race[i].frFR3;
            elseif (QTR_lang=="ES") then
               player_race = p_race[i].esES3;
            elseif (QTR_lang=="PT") then
               player_race = p_race[i].ptBR3;
            else
               player_race = p_race[i].itIT3;
            end
            break;
         end
      end
      for i=1,12 do
         if (p_class[i].itIT3 == QTR_class) then
            if (QTR_lang=="RU") then
               player_class = p_class[i].ruRU3;
            elseif (QTR_lang=="EN") then
               player_class = p_class[i].enUS;
            elseif (QTR_lang=="DE") then
               player_class = p_class[i].deDE3;
            elseif (QTR_lang=="FR") then
               player_class = p_class[i].frFR3;
            elseif (QTR_lang=="ES") then
               player_class = p_class[i].esES3;
            elseif (QTR_lang=="PT") then
               player_class = p_class[i].ptBR3;
            else
               player_class = p_class[i].itIT3;
            end
            break;
         end
      end
   end
elseif (QTR_locale=="ptBR") then
   if (QTR_sex==2) then      -- Male
      for i=1,21 do
         if (p_race[i].itIT2 == QTR_race) then
            if (QTR_lang=="RU") then
               player_race = p_race[i].ruRU2;
            elseif (QTR_lang=="EN") then
               player_race = p_race[i].enUS;
            elseif (QTR_lang=="DE") then
               player_race = p_race[i].deDE2;
            elseif (QTR_lang=="FR") then
               player_race = p_race[i].frFR2;
            elseif (QTR_lang=="ES") then
               player_race = p_race[i].esES2;
            elseif (QTR_lang=="IT") then
               player_race = p_race[i].itIT2;
            else
               player_race = p_race[i].ptBR2;
            end
            break;
         end
      end
      for i=1,12 do
         if (p_class[i].ptBR2 == QTR_class) then
            if (QTR_lang=="RU") then
               player_class = p_class[i].ruRU2;
            elseif (QTR_lang=="EN") then
               player_class = p_class[i].enUS;
            elseif (QTR_lang=="DE") then
               player_class = p_class[i].deDE2;
            elseif (QTR_lang=="FR") then
               player_class = p_class[i].frFR2;
            elseif (QTR_lang=="ES") then
               player_class = p_class[i].esES2;
            elseif (QTR_lang=="IT") then
               player_class = p_class[i].itIT2;
            else
               player_class = p_class[i].ptBR2;
            end
            break;
         end
      end
   else              -- Female
      for i=1,21 do
         if (p_race[i].ptBR3 == QTR_race) then
            if (QTR_lang=="RU") then
               player_race = p_race[i].ruRU3;
            elseif (QTR_lang=="EN") then
               player_race = p_race[i].enUS;
            elseif (QTR_lang=="DE") then
               player_race = p_race[i].deDE3;
            elseif (QTR_lang=="FR") then
               player_race = p_race[i].frFR3;
            elseif (QTR_lang=="ES") then
               player_race = p_race[i].esES3;
            elseif (QTR_lang=="IT") then
               player_race = p_race[i].itIT3;
            else
               player_race = p_race[i].ptBR3;
            end
            break;
         end
      end
      for i=1,12 do
         if (p_class[i].ptBR3 == QTR_class) then
            if (QTR_lang=="RU") then
               player_class = p_class[i].ruRU3;
            elseif (QTR_lang=="EN") then
               player_class = p_class[i].enUS;
            elseif (QTR_lang=="DE") then
               player_class = p_class[i].deDE3;
            elseif (QTR_lang=="FR") then
               player_class = p_class[i].frFR3;
            elseif (QTR_lang=="ES") then
               player_class = p_class[i].esES3;
            elseif (QTR_lang=="IT") then
               player_class = p_class[i].itIT3;
            else
               player_class = p_class[i].ptBR3;
            end
            break;
         end
      end
   end
elseif (QTR_locale=="ruRU") then
   if (QTR_sex==2) then      -- Male
      for i=1,21 do
         if (p_race[i].ruRU2 == QTR_race) then
            if (QTR_lang=="EN") then
               player_race = p_race[i].enUS;
            elseif (QTR_lang=="DE") then
               player_race = p_race[i].deDE2;
            elseif (QTR_lang=="FR") then
               player_race = p_race[i].frFR2;
            elseif (QTR_lang=="ES") then
               player_race = p_race[i].esES2;
            else
               player_race = p_race[i].ruRU2;
            end
            break;
         end
      end
      for i=1,12 do
         if (p_class[i].ruRU2 == QTR_class) then
            if (QTR_lang=="EN") then
               player_class = p_class[i].enUS;
            elseif (QTR_lang=="DE") then
               player_class = p_class[i].deDE2;
            elseif (QTR_lang=="FR") then
               player_class = p_class[i].frFR2;
            elseif (QTR_lang=="ES") then
               player_class = p_class[i].esES2;
            else
               player_class = p_class[i].ruRU2;
            end
            break;
         end
      end
   else              -- Female
      for i=1,21 do
         if (p_race[i].ruRU3 == QTR_race) then
            if (QTR_lang=="EN") then
               player_race = p_race[i].enUS;
            elseif (QTR_lang=="DE") then
               player_race = p_race[i].deDE3;
            elseif (QTR_lang=="FR") then
               player_race = p_race[i].frFR3;
            elseif (QTR_lang=="ES") then
               player_race = p_race[i].esES3;
            else
               player_race = p_race[i].ruRU3;
            end
            break;
         end
      end
      for i=1,12 do
         if (p_class[i].ruRU3 == QTR_class) then
            if (QTR_lang=="EN") then
               player_class = p_class[i].enUS;
            elseif (QTR_lang=="DE") then
               player_class = p_class[i].deDE3;
            elseif (QTR_lang=="FR") then
               player_class = p_class[i].frFR3;
            elseif (QTR_lang=="ES") then
               player_class = p_class[i].esES3;
            else
               player_class = p_class[i].ruRU3;
            end
            break;
         end
      end
   end
else
   player_race = QTR_race;
   player_class= QTR_class;
end



-- Zmienne programowe zapisane na stałe na komputerze
function QTR_CheckVars()
  if (not QTR_PS) then
     QTR_PS = {};		-- ustawienia dodatku
  end
  if (not QC_SAVED) then
     QC_SAVED = {};		-- zapis oryginalnych tekstów
  end
  -- inicjalizacja: tłumaczenia włączone
  if (not QTR_PS["active"]) then
     QTR_PS["active"] = "1";
  end
  -- inicjalizacja: tłumaczenie tytułu questu włączone
  if (not QTR_PS["transtitle"] ) then
     QTR_PS["transtitle"] = "1";   
  end
  if (not QTR_PS["showbutton"] ) then
     QTR_PS["showbutton"] = "1";   
  end
  if (not QTR_PS["lang"] ) then
     QTR_PS["lang"] = "1";   
  end
  -- zmienna specjalna dostępności funkcji GetQuestID 
  if ( QTR_PS["isGetQuestID"] ) then
     isGetQuestID=QTR_PS["isGetQuestID"];
  end;
end



-- Sprawdza dostępność funkcji specjalnej Wow'a: GetQuestID()
function DetectEmuServer()
  QTR_PS["isGetQuestID"]="0";
  isGetQuestID="0";
  -- funkcja GetQuestID() występuje tylko na serwerach Blizzarda
  if ( GetQuestID() ) then
     QTR_PS["isGetQuestID"]="1";
     isGetQuestID="1";
  end
end



-- Obsługa komend slash
function QTR_SlashCommand(msg)
   if (msg=="on" or msg=="ON" or msg=="1") then
      if (QTR_PS["active"]=="1") then
         print ("QTR - "..QTR_Interface[QTR_PS["lang"]].is_on);
      else
         print ("|cffffff00QTR - "..QTR_Interface[QTR_PS["lang"]].turn_on);
         QTR_PS["active"] = "1";
         QTR_ToggleButton0:Enable();
         QTR_ToggleButton1:Enable();
         QTR_Translate_On(1);
      end
   elseif (msg=="off" or msg=="OFF" or msg=="0") then
      if (QTR_PS["active"]=="0") then
         print ("QTR - "..QTR_Interface[QTR_PS["lang"]].is_off);
      else
         print ("|cffffff00QTR - "..QTR_Interface[QTR_PS["lang"]].turn_off);
         QTR_PS["active"] = "0";
         QTR_ToggleButton0:Disable();
         QTR_ToggleButton1:Disable();
         QTR_Translate_Off(1);
      end
   elseif (msg=="title on" or msg=="TITLE ON" or msg=="title 1") then
      if (QTR_PS["transtilte"]=="1") then
         print ("QTR - "..QTR_Interface[QTR_PS["lang"]].title_is_on);
      else
         print ("|cffffff00QTR - "..QTR_Interface[QTR_PS["lang"]].title_turn_on);
         QTR_PS["transtitle"] = "1";
         QuestInfoTitleHeader:SetFont(QTR_Font1[QTR_PS["lang"]], 18);
      end
   elseif (msg=="title off" or msg=="TITLE OFF" or msg=="title 0") then
      if (QTR_PS["transtilte"]=="0") then
         print ("QTR - "..QTR_Interface[QTR_PS["lang"]].title_is_off);
      else
         print ("|cffffff00QTR - "..QTR_Interface[QTR_PS["lang"]].title_turn_off);
         QTR_PS["transtitle"] = "0";
         QuestInfoTitleHeader:SetFont(Original_Font1, 18);
      end
   elseif (msg=="title" or msg=="TITLE") then
      if (QTR_PS["transtilte"]=="1") then
         print ("QTR - "..QTR_Interface[QTR_PS["lang"]].title_is_on);
      else
         print ("QTR - "..QTR_Interface[QTR_PS["lang"]].title_is_off);
      end
   elseif (msg=="") then
      InterfaceOptionsFrame_Show();
      InterfaceOptionsFrame_OpenToCategory("QTR-Quests");
   else
      print (QTR_Interface.quick_menu);
   end
end



function QTR_SetCheckButtonState()
  QTRCheckButton0:SetChecked(QTR_PS["active"]=="1");
  QTRCheckButton3:SetChecked(QTR_PS["transtitle"]=="1");
  QTRCheckButton5:SetChecked(QTR_PS["showbutton"]=="1");
  QTRLangButton1:SetChecked(QTR_PS["lang"]=="1");
  QTRLangButton2:SetChecked(QTR_PS["lang"]=="2");
  QTRLangButton3:SetChecked(QTR_PS["lang"]=="3");
  QTRLangButton9:SetChecked(QTR_PS["lang"]=="9");
end



function QTR_BlizzardOptions()
  -- Create main frame for information text
  local QTROptions = CreateFrame("FRAME", "QTR_Quests_Options");
  QTROptions.name = "QTR-Quests";
  QTROptions.refresh = function (self) QTR_SetCheckButtonState() end;
  InterfaceOptions_AddCategory(QTROptions);

  local QTROptionsHeader = QTROptions:CreateFontString(nil, "ARTWORK");
  QTROptionsHeader:SetFontObject(GameFontNormalLarge);
  QTROptionsHeader:SetJustifyH("LEFT"); 
  QTROptionsHeader:SetJustifyV("TOP");
  QTROptionsHeader:ClearAllPoints();
  QTROptionsHeader:SetPoint("TOPLEFT", 16, -16);
  QTROptionsHeader:SetText("QTR-Quests, ver. "..QTR_version.."   "..QTR_date.. " ("..QTR_base..") by Platine © 2021");

  QTRCheckButton0 = CreateFrame("CheckButton", "QTRCheckButton0", QTROptions, "OptionsCheckButtonTemplate");
  QTRCheckButton0:SetPoint("TOPLEFT", QTROptionsHeader, "BOTTOMLEFT", 0, -30);
  QTRCheckButton0:SetScript("OnClick", function(self) if (QTR_PS["active"]=="1") then QTR_PS["active"]="0" else QTR_PS["active"]="1" end; end);
  QTRCheckButton0Text:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
  QTRCheckButton0Text:SetText(QTR_Interface[QTR_PS["lang"]].active);

  QTRCheckButton3 = CreateFrame("CheckButton", "QTRCheckButton3", QTROptions, "OptionsCheckButtonTemplate");
  QTRCheckButton3:SetPoint("TOPLEFT", QTRCheckButton0, "BOTTOMLEFT", 50, -10);
  QTRCheckButton3:SetScript("OnClick", function(self) if (QTR_PS["transtitle"]=="0") then QTR_PS["transtitle"]="1" else QTR_PS["transtitle"]="0" end; end);
  QTRCheckButton3Text:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
  QTRCheckButton3Text:SetText(QTR_Interface[QTR_PS["lang"]].transtitle);

  QTRCheckButton5 = CreateFrame("CheckButton", "QTRCheckButton5", QTROptions, "OptionsCheckButtonTemplate");
  QTRCheckButton5:SetPoint("TOPLEFT", QTRCheckButton3, "BOTTOMLEFT", 0, -5);
  QTRCheckButton5:SetScript("OnClick", function(self) if (QTR_PS["showbutton"]=="0") then QTR_PS["showbutton"]="1" else QTR_PS["showbutton"]="0" end; end);
  QTRCheckButton5Text:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
  QTRCheckButton5Text:SetText(QTR_Interface[QTR_PS["lang"]].showbutton);

  QTRLangButton0 = QTROptions:CreateFontString(nil, "ARTWORK");
  QTRLangButton0:SetFontObject(GameFontWhite);
  QTRLangButton0:SetJustifyH("LEFT");
  QTRLangButton0:SetJustifyV("TOP");
  QTRLangButton0:ClearAllPoints();
  QTRLangButton0:SetPoint("TOPLEFT", QTRCheckButton5, "BOTTOMLEFT", 0, -30);
  QTRLangButton0:SetFont(QTR_Font2[QTR_PS["lang"]], 18);
  QTRLangButton0:SetText(QTR_Interface[QTR_PS["lang"]].checklang);

  local QTRLangButton1 = CreateFrame("CheckButton", "QTRLangButton1", QTROptions, "OptionsCheckButtonTemplate");
  QTRLangButton1:SetPoint("TOPLEFT", QTRLangButton0, "BOTTOMLEFT", 0, -10);
  QTRLangButton1:SetScript("OnClick", function(self) if ((QTR_PS["lang"]=="2") or (QTR_PS["lang"]=="3") or (QTR_PS["lang"]=="9")) then QTR_PS["lang"]="1";QTRLangButton2:SetChecked(false);QTRLangButton3:SetChecked(false);QTRLangButton9:SetChecked(false);QTRChangeLang(); else QTRLangButton1:SetChecked(true); end; end);
  QTRLangButton1Text:SetFont(QTR_Font2["1"], 13);
  QTRLangButton1Text:SetText(QTR_languages["1"]);

  local QTRLangButton2 = CreateFrame("CheckButton", "QTRLangButton2", QTROptions, "OptionsCheckButtonTemplate");
  QTRLangButton2:SetPoint("TOPLEFT", QTRLangButton1, "BOTTOMLEFT", 0, -5);
  QTRLangButton2:SetScript("OnClick", function(self) if ((QTR_PS["lang"]=="1") or (QTR_PS["lang"]=="3") or (QTR_PS["lang"]=="9")) then QTR_PS["lang"]="2";QTRLangButton1:SetChecked(false);QTRLangButton3:SetChecked(false);QTRLangButton9:SetChecked(false);QTRChangeLang(); else QTRLangButton2:SetChecked(true); end; end);
  QTRLangButton2Text:SetFont(QTR_Font2["1"], 13);
  QTRLangButton2Text:SetText(QTR_languages["2"]);

  local QTRLangButton3 = CreateFrame("CheckButton", "QTRLangButton3", QTROptions, "OptionsCheckButtonTemplate");
  QTRLangButton3:SetPoint("TOPLEFT", QTRLangButton2, "BOTTOMLEFT", 0, -5);
  QTRLangButton3:SetScript("OnClick", function(self) if ((QTR_PS["lang"]=="1") or (QTR_PS["lang"]=="2") or (QTR_PS["lang"]=="9")) then QTR_PS["lang"]="3";QTRLangButton1:SetChecked(false);QTRLangButton2:SetChecked(false);QTRLangButton9:SetChecked(false);QTRChangeLang(); else QTRLangButton3:SetChecked(true); end; end);
  QTRLangButton3Text:SetFont(QTR_Font2["1"], 13);
  QTRLangButton3Text:SetText(QTR_languages["3"]);

  local QTRLangButton9 = CreateFrame("CheckButton", "QTRLangButton9", QTROptions, "OptionsCheckButtonTemplate");
  QTRLangButton9:SetPoint("TOPLEFT", QTRLangButton3, "TOPLEFT", 120, 0);
  QTRLangButton9:SetScript("OnClick", function(self) if ((QTR_PS["lang"]=="1") or (QTR_PS["lang"]=="2") or (QTR_PS["lang"]=="3")) then QTR_PS["lang"]="9";QTRLangButton1:SetChecked(false);QTRLangButton2:SetChecked(false);QTRLangButton3:SetChecked(false);QTRChangeLang(); else QTRLangButton9:SetChecked(true); end; end);
  QTRLangButton9Text:SetFont(QTR_Font2["1"], 13);
  QTRLangButton9Text:SetText(QTR_languages["9"]);

  local QTRSlachCommand = QTROptions:CreateFontString(nil, "ARTWORK");
  QTRSlachCommand:SetFontObject(GameFontWhite);
  QTRSlachCommand:SetJustifyH("LEFT"); 
  QTRSlachCommand:SetJustifyV("TOP");
  QTRSlachCommand:ClearAllPoints();
  QTRSlachCommand:SetPoint("TOPLEFT", QTRLangButton3, "BOTTOMLEFT", -50, -30);
  QTRSlachCommand:SetText("Slash command: /qtr-quests  or  /qtrq ");
  QTRSlachCommand:SetFont(QTR_Font2[QTR_PS["lang"]], 14);

  local QTROptionsText1 = QTROptions:CreateFontString(nil, "ARTWORK");
  QTROptionsText1:SetFontObject(GameFontNormal);
  QTROptionsText1:SetJustifyH("LEFT"); 
  QTROptionsText1:SetJustifyV("TOP");
  QTROptionsText1:ClearAllPoints();
  QTROptionsText1:SetPoint("TOPLEFT", QTRSlachCommand, "BOTTOMLEFT", 0, -30);
  QTROptionsText1:SetFont(QTR_Font2["1"], 13);
  QTROptionsText1:SetText("This addon saves the quest texts from your realm ("..QTR_locale..").");

  local QTROptionsText2 = QTROptions:CreateFontString(nil, "ARTWORK");
  QTROptionsText2:SetFontObject(GameFontNormal);
  QTROptionsText2:SetJustifyH("LEFT"); 
  QTROptionsText2:SetJustifyV("TOP");
  QTROptionsText2:ClearAllPoints();
  QTROptionsText2:SetPoint("TOPLEFT", QTROptionsText1, "BOTTOMLEFT", 0, 0);
  QTROptionsText2:SetFont(QTR_Font2["1"], 13);
  QTROptionsText2:SetText("This datas can be used to create a quest database in that language.");

  local QTROptionsText3 = QTROptions:CreateFontString(nil, "ARTWORK");
  QTROptionsText3:SetFontObject(GameFontNormal);
  QTROptionsText3:SetJustifyH("LEFT"); 
  QTROptionsText3:SetJustifyV("TOP");
  QTROptionsText3:ClearAllPoints();
  QTROptionsText3:SetPoint("TOPLEFT", QTROptionsText2, "BOTTOMLEFT", 0, 0);
  QTROptionsText3:SetFont(QTR_Font2["1"], 13);
  QTROptionsText3:SetText("This way, other players will be able to display "..QTR_locale.." quests while playing on other realms.");

  local QTROptionsText4 = QTROptions:CreateFontString(nil, "ARTWORK");
  QTROptionsText4:SetFontObject(GameFontWhite);
  QTROptionsText4:SetJustifyH("LEFT"); 
  QTROptionsText4:SetJustifyV("TOP");
  QTROptionsText4:ClearAllPoints();
  QTROptionsText4:SetPoint("TOPLEFT", QTROptionsText3, "BOTTOMLEFT", 0, -20);
  QTROptionsText4:SetFont(QTR_Font2["1"], 13);
  QTROptionsText4:SetText("Please help us and send your file with the saved texts from your original realm.");

  local QTROptionsText5 = QTROptions:CreateFontString(nil, "ARTWORK");
  QTROptionsText5:SetFontObject(GameFontWhite);
  QTROptionsText5:SetJustifyH("LEFT"); 
  QTROptionsText5:SetJustifyV("TOP");
  QTROptionsText5:ClearAllPoints();
  QTROptionsText5:SetPoint("TOPLEFT", QTROptionsText4, "BOTTOMLEFT", 0, -7);
  QTROptionsText5:SetFont(QTR_Font2["1"], 13);
  QTROptionsText5:SetText("This file is localed on your hard drive in a folder:");

  local QTROptionsText6 = QTROptions:CreateFontString(nil, "ARTWORK");
  QTROptionsText6:SetFontObject(GameFontNormal);
  QTROptionsText6:SetJustifyH("LEFT"); 
  QTROptionsText6:SetJustifyV("TOP");
  QTROptionsText6:ClearAllPoints();
  QTROptionsText6:SetPoint("TOPLEFT", QTROptionsText5, "BOTTOMLEFT", 0, -10);
  QTROptionsText6:SetFont(QTR_Font2["1"], 13);
  QTROptionsText6:SetText("c:\\World of Warcraft\\_classic_\\WTF\\Account\\[ServerNumber]\\SavedVariables\\QTR_Quest.lua");

  local QTROptionsText7 = QTROptions:CreateFontString(nil, "ARTWORK");
  QTROptionsText7:SetFontObject(GameFontWhite);
  QTROptionsText7:SetJustifyH("LEFT"); 
  QTROptionsText7:SetJustifyV("TOP");
  QTROptionsText7:ClearAllPoints();
  QTROptionsText7:SetPoint("TOPLEFT", QTROptionsText6, "BOTTOMLEFT", 0, -10);
  QTROptionsText7:SetFont(QTR_Font2["1"], 13);
  QTROptionsText7:SetText("We have prepared a special website with a form for sending this file to our server.");

  local QTRWWW1 = QTROptions:CreateFontString(nil, "ARTWORK");
  QTRWWW1:SetFontObject(GameFontWhite);
  QTRWWW1:SetJustifyH("LEFT");
  QTRWWW1:SetJustifyV("TOP");
  QTRWWW1:ClearAllPoints();
  QTRWWW1:SetPoint("TOPLEFT", QTROptionsText7, "BOTTOMLEFT", 0, -10);
  QTRWWW1:SetFont(QTR_Font2["1"], 13);
  QTRWWW1:SetText("Please visit our project page: ");
  
  local QTRWWW2 = CreateFrame("EditBox", "QTRWWW2", QTROptions, "InputBoxTemplate");
  QTRWWW2:ClearAllPoints();
  QTRWWW2:SetPoint("TOPLEFT", QTRWWW1, "TOPRIGHT", 10, 4);
  QTRWWW2:SetHeight(20);
  QTRWWW2:SetWidth(350);
  QTRWWW2:SetAutoFocus(false);
  QTRWWW2:SetFontObject(GameFontGreen);
  QTRWWW2:SetText("https://panel.wowpopolsku.pl/qtr_quests.php#2");
  QTRWWW2:SetCursorPosition(0);
  QTRWWW2:SetScript("OnEnter", function(self)
	  GameTooltip:SetOwner(self, "ANCHOR_TOPRIGHT")
      getglobal("GameTooltipTextLeft1"):SetFont(QTR_Font2["1"], 13);
  	  GameTooltip:SetText("click and press Ctrl+C to copy to clipboard", nil, nil, nil, nil, true)
	  GameTooltip:Show() --Show the tooltip
     end);
  QTRWWW2:SetScript("OnLeave", function(self)
      getglobal("GameTooltipTextLeft1"):SetFont(QTR_Font2["1"], 13);
	  GameTooltip:Hide() --Hide the tooltip
     end);
  QTRWWW2:SetScript("OnTextChanged", function(self) QTRWWW2:SetText("https://panel.wowpopolsku.pl/qtr_quests.php#2"); end);
  
  local QTRWWW3 = QTROptions:CreateFontString(nil, "ARTWORK");
  QTRWWW3:SetFontObject(GameFontWhite);
  QTRWWW3:SetJustifyH("LEFT");
  QTRWWW3:SetJustifyV("TOP");
  QTRWWW3:ClearAllPoints();
  QTRWWW3:SetPoint("TOPLEFT", QTRWWW1, "BOTTOMLEFT", 0, -10);
  QTRWWW3:SetFont(QTR_Font2["1"], 13);
  QTRWWW3:SetText("and upload your file with saved texts of quests from your realm ("..QTR_locale..").          Thanks");
  
end


function QTRChangeLang()
  QTRCheckButton0Text:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
  QTRCheckButton0Text:SetText(QTR_Interface[QTR_PS["lang"]].active);
  QTRCheckButton3Text:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
  QTRCheckButton3Text:SetText(QTR_Interface[QTR_PS["lang"]].transtitle);
  QTRCheckButton5Text:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
  QTRCheckButton5Text:SetText(QTR_Interface[QTR_PS["lang"]].showbutton);
  QTRLangButton0:SetFont(QTR_Font2[QTR_PS["lang"]], 18);
  QTRLangButton0:SetText(QTR_Interface[QTR_PS["lang"]].checklang);
  QTR_quest_EN = { };
  QTR_quest_LG = { };
  QTR_quest_EN[0] = { };
  QTR_quest_LG[0] = { };
end


function QTR_SaveQuest(event)          -- zapisujemy dane questów z tego realmu
   QC_SAVED[QTR_quest_ID.." PLAYER"]=QTR_name..":"..QTR_race..":"..QTR_class..":"..QTR_sex;  -- save player information
   QC_SAVED[QTR_quest_ID.." REALM"]=QTR_locale..":"..GetBuildInfo();                         -- save realm information
   if (event=="QUEST_DETAIL") then
      QC_SAVED[QTR_quest_ID.." TITLE"]=GetTitleText();            -- save original title to create this realm databases
      QC_SAVED[QTR_quest_ID.." DESCRIPTION"]=GetQuestText();      -- save original text to create this realm databases
      QC_SAVED[QTR_quest_ID.." OBJECTIVE"]=GetObjectiveText();    -- save original text to create this realm databases
   end
   if (event=="QUEST_PROGRESS") then
      QC_SAVED[QTR_quest_ID.." PROGRESS"]=GetProgressText();      -- save original text to create this realm databases
   end
   if (event=="QUEST_COMPLETE") then
      QC_SAVED[QTR_quest_ID.." COMPLETE"]=GetRewardText();        -- save original text to create this realm databases
   end
end


function QTR_wait(delay, func, ...)
  if(type(delay)~="number" or type(func)~="function") then
    return false;
  end
  if(QTR_waitFrame == nil) then
    QTR_waitFrame = CreateFrame("Frame","QTR_WaitFrame", UIParent);
    QTR_waitFrame:SetScript("onUpdate",function (self,elapse)
      local count = #QTR_waitTable;
      local i = 1;
      while(i<=count) do
        local waitRecord = tremove(QTR_waitTable,i);
        local d = tremove(waitRecord,1);
        local f = tremove(waitRecord,1);
        local p = tremove(waitRecord,1);
        if(d>elapse) then
          tinsert(QTR_waitTable,i,{d-elapse,f,p});
          i = i + 1;
        else
          count = count - 1;
          f(unpack(p));
        end
      end
    end);
  end
  tinsert(QTR_waitTable,{delay,func,{...}});
  return true;
end


function QTR_Prepare1sek()
   if (not QTR_wait(0.1,QTR_PrepareReload)) then
   ---
   end
end;      


-- Otworzono pusty QuestLog
function QTR_EmptyQuestLog()
   QTR_ToggleButton1:Hide();
end


function QTR_ON_OFF()
   if (curr_trans=="1") then
      curr_trans="0";
      QTR_Translate_Off(1);
   else   
      curr_trans="1";
      QTR_Translate_On(1);
   end
end


-- Określa aktualny numer ID questu z różnych metod
function QTR_GetQuestID()
   if ( isGetQuestID=="1" ) then
      quest_ID = GetQuestID();
   end
   
   if ((QuestLogFrame:IsVisible() ) and ((quest_ID==nil) or (quest_ID==0))) then
      local questTitle, level, questTag, isHeader, isCollapsed, isComplete, isDaily, questID = GetQuestLogTitle(GetQuestLogSelection());
      quest_ID = questID;
   end
   
   if ((quest_ID==nil) and (QuestFrame)) then
      quest_ID = QuestFrame.questID;
   end
   if ((quest_ID==nil) and (QuestLogPopupDetailFrame)) then
      quest_ID = QuestLogPopupDetailFrame.questID;
   end
       
   return (quest_ID);
end



-- Wywoływane przy przechwytywanych zdarzeniach
function QTR_OnEvent(self, event, name, ...)
   if (event=="ADDON_LOADED" and name=="QTR_Quests") then
      QTR:RegisterEvent("QUEST_DETAIL");
      QTR:RegisterEvent("QUEST_PROGRESS");
      QTR:RegisterEvent("QUEST_COMPLETE");
      QTR_CheckVars();

      -- przycisk z nr ID questu w QuestFrame (NPC)
      QTR_ToggleButton0 = CreateFrame("Button",nil, QuestFrame, "UIPanelButtonTemplate");
      QTR_ToggleButton0:SetWidth(200);
      QTR_ToggleButton0:SetHeight(20);
      QTR_ToggleButton0:SetText("Quest ID=?");
      QTR_ToggleButton0:Show();
      QTR_ToggleButton0:ClearAllPoints();
      QTR_ToggleButton0:SetPoint("TOPLEFT", QuestFrame, "TOPLEFT", 92, -50);
      QTR_ToggleButton0:SetScript("OnClick", QTR_ON_OFF);
      
      -- przycisk z nr ID questu w QuestFrameProgressPanel
      QTR_ToggleButton1 = CreateFrame("Button",nil, QuestLogFrame, "UIPanelButtonTemplate");
      QTR_ToggleButton1:SetWidth(170);
      QTR_ToggleButton1:SetHeight(20);
      QTR_ToggleButton1:SetText("Quest ID=?");
      QTR_ToggleButton1:Show();
      QTR_ToggleButton1:ClearAllPoints();
      QTR_ToggleButton1:SetPoint("TOPLEFT", QuestLogFrame, "TOPLEFT", 178, -58);
      QTR_ToggleButton1:SetScript("OnClick", QTR_ON_OFF);

      -- przycisk z opcjonalnym napisem "brak tłumaczenia" w oknie QuestFrame ProgressPAnel
      QTR_ToggleButton2 = CreateFrame("Button",nil, QuestFrame, "UIPanelButtonTemplate");
      QTR_ToggleButton2:SetWidth(200);
      QTR_ToggleButton2:SetHeight(20);
      QTR_ToggleButton2:SetText(QTR_Messages[QTR_PS["lang"]].missing);
      QTR_ToggleButton2:Hide();
      QTR_ToggleButton2:Disable();
      QTR_ToggleButton2:ClearAllPoints();
      QTR_ToggleButton2:SetPoint("CENTER", QTR_ToggleButton0, "CENTER", 0, -15);

      -- funkcja wywoływana po kliknięciu na nazwę questu w QuestTracker   
--      hooksecurefunc(QUEST_TRACKER_MODULE, "OnBlockHeaderClick", QTR_Prepare1sek);
      
      -- funkcja wywoływana po kliknięciu na nazwę questu w QuestMapFrame
--      hooksecurefunc("QuestMapFrame_ShowQuestDetails", QTR_Prepare1sek);
   
      QuestLogDetailScrollFrame:HookScript("OnShow", QTR_Prepare1sek);
      EmptyQuestLogFrame:HookScript("OnShow", QTR_EmptyQuestLog);
      hooksecurefunc("SelectQuestLogEntry", QTR_Prepare1sek);

      SlashCmdList["QTR_QUESTS"] = function(msg) QTR_SlashCommand(msg); end
      SLASH_QTR_QUESTS1 = "/qtr-quests";
      SLASH_QTR_QUESTS2 = "/qtrq";
      -- twórz interface Options w Blizzard-Interface-Addons
      QTR_BlizzardOptions();
      print ("|cffffff00QTR-Quests ver. "..QTR_version.." ("..QTR_lang[QTR_PS["lang"]]..") - "..QTR_Messages[QTR_PS["lang"]].loaded);
      QTR:UnregisterEvent("ADDON_LOADED");
      QTR.ADDON_LOADED = nil;
      if (not isGetQuestID) then
         DetectEmuServer();
      end
      
   elseif (event=="QUEST_DETAIL" or event=="QUEST_PROGRESS" or event=="QUEST_COMPLETE") then
      if ( QuestFrame:IsVisible() ) then
         QTR_QuestPrepare(event);
      end
   end
end


-- Otworzono okienko QuestLog lub QuestLogPopupDetailFrame lub QuestMapDetailsScrollFrame
function QTR_QuestPrepare(zdarzenie)
   if (QTR_PS["showbutton"]=="1") then
      QTR_ToggleButton0:Show();
      QTR_ToggleButton1:Show();
   else
      QTR_ToggleButton0:Hide();
      QTR_ToggleButton1:Hide();
   end
   QTR_ToggleButton2:Hide();        -- brak tłumaczenia w QuestFrame
   q_ID = QTR_GetQuestID();
   str_ID = tostring(q_ID);
   QTR_quest_ID = q_ID;   
   if ( not (QTR_quest_EN[QTR_quest_ID])) then
      QTR_quest_EN[QTR_quest_ID] = { };
      QTR_quest_LG[QTR_quest_ID] = { };
   end
   QTR_SaveQuest(zdarzenie);           -- zapisz teksty questów z tego realmu
   if ( QTR_PS["active"]=="1" ) then	-- tłumaczenia włączone
      QTR_ToggleButton0:Enable();
      QTR_ToggleButton1:Enable();
      curr_trans = "1";
      if ( QTR_QuestData[QTR_PS["lang"]][str_ID] ) then   -- wyświetlaj tylko, gdy istnieje tłumaczenie
         if (QTR_quest_EN[QTR_quest_ID].title == nil) then
            QTR_quest_LG[QTR_quest_ID].title = QTR_ExpandUnitInfo(QTR_QuestData[QTR_PS["lang"]][str_ID]["Title"]);
            QTR_quest_EN[QTR_quest_ID].title = GetTitleText();
            if (QTR_quest_EN[QTR_quest_ID].title=="") then
               QTR_quest_EN[QTR_quest_ID].title=QuestInfoTitleHeader:GetText();
            end
         end
         if (QTR_quest_LG[QTR_quest_ID].details == nil) then
            QTR_quest_LG[QTR_quest_ID].details = QTR_ExpandUnitInfo(QTR_QuestData[QTR_PS["lang"]][str_ID]["Description"]);
            QTR_quest_LG[QTR_quest_ID].objectives = QTR_ExpandUnitInfo(QTR_QuestData[QTR_PS["lang"]][str_ID]["Objectives"]);
         end
         if (zdarzenie=="QUEST_DETAIL") then
            if (QTR_quest_EN[QTR_quest_ID].details == nil) then
               QTR_quest_EN[QTR_quest_ID].details = GetQuestText();
               QTR_quest_EN[QTR_quest_ID].objectives = GetObjectiveText();
            end
            -- sprawdź ile jest nagród za ten quest?
            quest_numReward[str_ID] = GetNumQuestChoices();
            if (quest_numReward[str_ID]>1) then
               QTR_quest_EN[QTR_quest_ID].itemchoose = QTR_MessOrig.itemchoose1;
               QTR_quest_LG[QTR_quest_ID].itemchoose = QTR_Messages[QTR_PS["lang"]].itemchoose1;
            else
               QTR_quest_EN[QTR_quest_ID].itemchoose = QTR_MessOrig.itemchoose0;
               QTR_quest_LG[QTR_quest_ID].itemchoose = QTR_Messages[QTR_PS["lang"]].itemchoose0;
            end
            -- czy jest jeszcze kasa w nagrodę? a może jest tylko sama kasa?
            if (quest_numReward[str_ID]>0) then
               QTR_quest_EN[QTR_quest_ID].itemreceive = QTR_MessOrig.itemreceiv1;
               QTR_quest_LG[QTR_quest_ID].itemreceive = QTR_Messages[QTR_PS["lang"]].itemreceiv1;
            else
               QTR_quest_EN[QTR_quest_ID].itemreceive = QTR_MessOrig.itemreceiv0;
               QTR_quest_LG[QTR_quest_ID].itemreceive = QTR_Messages[QTR_PS["lang"]].itemreceiv0;
            end
         else   
            if (QTR_quest_EN[QTR_quest_ID].details == nil) then
               if (QuestFrame:IsVisible()) then
                  QTR_quest_EN[QTR_quest_ID].details = QuestInfoDescriptionText:GetText();
               end
               if (QuestLogFrame:IsVisible()) then
                  QTR_quest_EN[QTR_quest_ID].details = QuestLogQuestDescription:GetText();
               end
            end
            if (QTR_quest_EN[QTR_quest_ID].objectives == nil) then
               if (QuestFrame:IsVisible()) then
                  QTR_quest_EN[QTR_quest_ID].objectives = QuestInfoObjectivesText:GetText();
               end
               if (QuestLogFrame:IsVisible()) then         
                  QTR_quest_EN[QTR_quest_ID].objectives = QuestLogObjectivesText:GetText();
               end
            end
            if (quest_numReward[str_ID]==nil) then         -- mamy zapamiętaną liczbę nagród do tego questu
               QTR_quest_EN[QTR_quest_ID].itemchoose = QTR_MessOrig.itemchoose0;
               QTR_quest_LG[QTR_quest_ID].itemchoose = QTR_Messages[QTR_PS["lang"]].itemchoose0;
               if (MapQuestInfoRewardsFrame.ItemChooseText:IsVisible()) then
                  QTR_quest_EN[QTR_quest_ID].itemreceive = QTR_MessOrig.itemreceiv1;
                  QTR_quest_LG[QTR_quest_ID].itemreceive = QTR_Messages[QTR_PS["lang"]].itemreceiv1;                  
               else
                  QTR_quest_EN[QTR_quest_ID].itemreceive = QTR_MessOrig.itemreceiv0;
                  QTR_quest_LG[QTR_quest_ID].itemreceive = QTR_Messages[QTR_PS["lang"]].itemreceiv0;
               end
            else
               if (quest_numReward[str_ID]>1) then
                  QTR_quest_EN[QTR_quest_ID].itemchoose = QTR_MessOrig.itemchoose1;
                  QTR_quest_LG[QTR_quest_ID].itemchoose = QTR_Messages[QTR_PS["lang"]].itemchoose1;
               else
                  QTR_quest_EN[QTR_quest_ID].itemchoose = QTR_MessOrig.itemchoose0;
                  QTR_quest_LG[QTR_quest_ID].itemchoose = QTR_Messages[QTR_PS["lang"]].itemchoose0;
               end
               -- czy jest jeszcze kasa w nagrodę? a może jest tylko sama kasa?
               if (quest_numReward[str_ID]>0) then
                  QTR_quest_EN[QTR_quest_ID].itemreceive = QTR_MessOrig.itemreceiv1;
                  QTR_quest_LG[QTR_quest_ID].itemreceive = QTR_Messages[QTR_PS["lang"]].itemreceiv1;
               else
                  QTR_quest_EN[QTR_quest_ID].itemreceive = QTR_MessOrig.itemreceiv0;
                  QTR_quest_LG[QTR_quest_ID].itemreceive = QTR_Messages[QTR_PS["lang"]].itemreceiv0;
               end
            end
         end   
         if (zdarzenie=="QUEST_PROGRESS") then
            if (QTR_quest_EN[QTR_quest_ID].progress == nil) then
               QTR_quest_EN[QTR_quest_ID].progress = GetProgressText();
               QTR_quest_LG[QTR_quest_ID].progress = QTR_ExpandUnitInfo(QTR_QuestData[QTR_PS["lang"]][str_ID]["Progress"]);
            end
         end
         if (zdarzenie=="QUEST_COMPLETE") then
            if (QTR_quest_EN[QTR_quest_ID].completion == nil) then
               QTR_quest_EN[QTR_quest_ID].completion = GetRewardText();
               QTR_quest_LG[QTR_quest_ID].completion = QTR_ExpandUnitInfo(QTR_QuestData[QTR_PS["lang"]][str_ID]["Completion"]);
            end
            -- sprawdź ile jest nagród za ten quest?
            if (quest_numReward[str_ID]==nil) then
               quest_numReward[str_ID] = GetNumQuestChoices();
            end
            if (quest_numReward[str_ID]>1) then
               QTR_quest_EN[QTR_quest_ID].itemchoose = QTR_MessOrig.itemchoose2;
               QTR_quest_LG[QTR_quest_ID].itemchoose = QTR_Messages[QTR_PS["lang"]].itemchoose2;
            else
               QTR_quest_EN[QTR_quest_ID].itemchoose = QTR_MessOrig.itemchoose3;
               QTR_quest_LG[QTR_quest_ID].itemchoose = QTR_Messages[QTR_PS["lang"]].itemchoose3;
            end
            -- czy jest jeszcze kasa w nagrodę? a może jest tylko sama kasa?
            if (quest_numReward[str_ID]>0) then
               QTR_quest_EN[QTR_quest_ID].itemreceive = QTR_MessOrig.itemreceiv3;
               QTR_quest_LG[QTR_quest_ID].itemreceive = QTR_Messages[QTR_PS["lang"]].itemreceiv3;
            else
               QTR_quest_EN[QTR_quest_ID].itemreceive = QTR_MessOrig.itemreceiv2;
               QTR_quest_LG[QTR_quest_ID].itemreceive = QTR_Messages[QTR_PS["lang"]].itemreceiv2;
            end
         end         
         QTR_ToggleButton0:SetText("Quest ID="..QTR_quest_ID.." ("..QTR_lang[QTR_PS["lang"]]..")");
         QTR_ToggleButton1:SetText("Quest ID="..QTR_quest_ID.." ("..QTR_lang[QTR_PS["lang"]]..")");
         QTR_Translate_On(1);
      else	      -- nie ma przetłumaczonego takiego questu
         QTR_ToggleButton0:Disable();
         QTR_ToggleButton1:Disable();
         QTR_ToggleButton2:Show();        -- brak tłumaczenia w QuestFrame
         QTR_ToggleButton0:SetText("Quest ID="..str_ID);
         QTR_ToggleButton1:SetText("Quest ID="..str_ID);
         QTR_Translate_On(0);
      end -- jest przetłumaczony quest w bazie
   else	-- tłumaczenia wyłączone
      QTR_ToggleButton0:Disable();
      QTR_ToggleButton1:Disable();
      if ( QTR_QuestData[QTR_PS["lang"]][str_ID] ) then	-- ale jest tłumaczenie w bazie
         QTR_ToggleButton1:SetText("Quest ID="..str_ID.." ("..QTR_locale..")");
      else
         QTR_ToggleButton1:SetText("Quest ID="..str_ID);
      end
   end	-- tłumaczenia są włączone
end


-- wyświetla tłumaczenie
function QTR_Translate_On(typ)
   QTR_display_constants(1);  
   if (typ==1) then			-- pełne przełączenie (jest tłumaczenie)
      local numer_ID = QTR_quest_ID;
      str_ID = tostring(numer_ID);
      if (numer_ID>0 and QTR_QuestData[QTR_PS["lang"]][str_ID]) then	-- przywróć przetłumaczoną wersję napisów
         QTR_ToggleButton0:SetText("Quest ID="..QTR_quest_ID.." ("..QTR_lang[QTR_PS["lang"]]..")");
         QTR_ToggleButton1:SetText("Quest ID="..QTR_quest_ID.." ("..QTR_lang[QTR_PS["lang"]]..")");
         if (QTR_PS["transtitle"]=="1") then
            QuestInfoTitleHeader:SetFont(QTR_Font1[QTR_PS["lang"]], 18);
            QuestProgressTitleText:SetFont(QTR_Font1[QTR_PS["lang"]], 18);
            QuestLogQuestTitle:SetFont(QTR_Font1[QTR_PS["lang"]], 18);
            QuestInfoTitleHeader:SetText(QTR_quest_LG[QTR_quest_ID].title);
            QuestProgressTitleText:SetText(QTR_quest_LG[QTR_quest_ID].title);
            QuestLogQuestTitle:SetText(QTR_quest_LG[QTR_quest_ID].title);
         end
         QuestInfoObjectivesText:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
         QuestInfoDescriptionText:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
         QuestProgressText:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
         QuestInfoRewardText:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
         QuestInfoObjectivesText:SetText(QTR_quest_LG[QTR_quest_ID].objectives);
         QuestInfoDescriptionText:SetText(QTR_quest_LG[QTR_quest_ID].details);
         QuestProgressText:SetText(QTR_quest_LG[QTR_quest_ID].progress);
         QuestInfoRewardText:SetText(QTR_quest_LG[QTR_quest_ID].completion);
         QuestLogQuestDescription:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
         QuestLogObjectivesText:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
         QuestLogQuestDescription:SetText(QTR_quest_LG[QTR_quest_ID].details);
         QuestLogObjectivesText:SetText(QTR_quest_LG[QTR_quest_ID].objectives);
      end
   end
end


-- wyświetla oryginalny tekst angielski
function QTR_Translate_Off(typ)
   QTR_display_constants(0);
   if (typ==1) then			-- pełne przełączenie (jest tłumaczenie)
      local numer_ID = QTR_quest_ID;
      str_ID = tostring(numer_ID);
      if (numer_ID>0 and QTR_QuestData[QTR_PS["lang"]][str_ID]) then	-- przywróć oryginalną wersję napisów
         QTR_ToggleButton0:SetText("Quest ID="..QTR_quest_ID.." ("..QTR_locale..")");
         QTR_ToggleButton1:SetText("Quest ID="..QTR_quest_ID.." ("..QTR_locale..")");
         QuestInfoTitleHeader:SetFont(Original_Font1, 18);
         QuestProgressTitleText:SetFont(Original_Font1, 18);
         QuestInfoTitleHeader:SetText(QTR_quest_EN[QTR_quest_ID].title);
         QuestProgressTitleText:SetText(QTR_quest_EN[QTR_quest_ID].title);
         QuestInfoDescriptionText:SetFont(Original_Font2, 13);
         QuestInfoObjectivesText:SetFont(Original_Font2, 13);
         QuestProgressText:SetFont(Original_Font2, 13);
         QuestInfoRewardText:SetFont(Original_Font2, 13);
         QuestInfoDescriptionText:SetText(QTR_quest_EN[QTR_quest_ID].details);
         QuestInfoObjectivesText:SetText(QTR_quest_EN[QTR_quest_ID].objectives);
         QuestProgressText:SetText(QTR_quest_EN[QTR_quest_ID].progress);
         QuestInfoRewardText:SetText(QTR_quest_EN[QTR_quest_ID].completion);
         QuestLogQuestDescription:SetFont(Original_Font2, 13);
         QuestLogObjectivesText:SetFont(Original_Font2, 13);
         QuestLogQuestDescription:SetText(QTR_quest_EN[QTR_quest_ID].details);
         QuestLogObjectivesText:SetText(QTR_quest_EN[QTR_quest_ID].objectives);
      end
   end
end


function QTR_display_constants(lg)
   if (lg==1) then        -- dane stałe po polsku
      if (Original_Font1==nil) then
         Original_Font1, _size1, _31 = QuestInfoTitleHeader:GetFont();
      end
      if (Original_Font2==nil) then
         Original_Font2, _size2, _32 = QuestInfoDescriptionText:GetFont();
      end
      QuestInfoObjectivesHeader:SetFont(QTR_Font1[QTR_PS["lang"]], 18);
      QuestInfoObjectivesHeader:SetText(QTR_Messages[QTR_PS["lang"]].objectives);
      QuestInfoRewardsFrame.Header:SetFont(QTR_Font1[QTR_PS["lang"]], 18);
      QuestInfoRewardsFrame.Header:SetText(QTR_Messages[QTR_PS["lang"]].rewards);
      QuestInfoDescriptionHeader:SetFont(QTR_Font1[QTR_PS["lang"]], 18);
      QuestInfoDescriptionHeader:SetText(QTR_Messages[QTR_PS["lang"]].details);
      QuestLogDescriptionTitle:SetFont(QTR_Font1[QTR_PS["lang"]], 18);
      QuestLogDescriptionTitle:SetText(QTR_Messages[QTR_PS["lang"]].details);
      QuestLogRewardTitleText:SetFont(QTR_Font1[QTR_PS["lang"]], 18);
      QuestLogRewardTitleText:SetText(QTR_Messages[QTR_PS["lang"]].rewards);
      QuestProgressRequiredItemsText:SetFont(QTR_Font1[QTR_PS["lang"]], 18);
      QuestProgressRequiredItemsText:SetText(QTR_Messages[QTR_PS["lang"]].reqitems);
      CurrentQuestsText:SetFont(QTR_Font1[QTR_PS["lang"]], 18);
      CurrentQuestsText:SetText(QTR_Messages[QTR_PS["lang"]].currquests);
      AvailableQuestsText:SetFont(QTR_Font1[QTR_PS["lang"]], 18);
      AvailableQuestsText:SetText(QTR_Messages[QTR_PS["lang"]].avaiquests);
--      local regions = { QuestMapFrame.DetailsFrame.RewardsFrame:GetRegions() };
--      for index = 1, #regions do
--         local region = regions[index];
--         if ((region:GetObjectType() == "FontString") and (region:GetText() == QUEST_REWARDS)) then
--            region:SetText(QTR_Messages[QTR_PS["lang"]].rewards);
--         end
--      end
      
      -- stałe elementy okna zadania:
      QuestInfoRewardsFrame.ItemChooseText:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
      QuestInfoRewardsFrame.ItemReceiveText:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
      QuestInfoRewardsFrame.ItemChooseText:SetText(QTR_quest_LG[QTR_quest_ID].itemchoose);
      QuestInfoRewardsFrame.ItemReceiveText:SetText(QTR_quest_LG[QTR_quest_ID].itemreceive);
      QuestInfoSpellObjectiveLearnLabel:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
      QuestInfoSpellObjectiveLearnLabel:SetText(QTR_Messages[QTR_PS["lang"]].learnspell);
      QuestInfoXPFrame.ReceiveText:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
      QuestInfoXPFrame.ReceiveText:SetText(QTR_Messages[QTR_PS["lang"]].experience);
      QuestInfoRewardsFrame.XPFrame.ReceiveText:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
      QuestInfoRewardsFrame.XPFrame.ReceiveText:SetText(QTR_Messages[QTR_PS["lang"]].experience);
--1      MapQuestInfoRewardsFrame.ItemChooseText:SetFont(QTR_Font2[QTR_PS["lang"]], 11);
--1      MapQuestInfoRewardsFrame.ItemReceiveText:SetFont(QTR_Font2[QTR_PS["lang"]], 11);
--1      MapQuestInfoRewardsFrame.ItemChooseText:SetText(QTR_quest_LG[QTR_quest_ID].itemchoose);
--1      MapQuestInfoRewardsFrame.ItemReceiveText:SetText(QTR_quest_LG[QTR_quest_ID].itemreceive);
      QuestLogItemChooseText:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
      QuestLogItemChooseText:SetText(QTR_quest_LG[QTR_quest_ID].itemchoose);
      QuestInfoRewardsFrame.PlayerTitleText:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
      QuestInfoRewardsFrame.PlayerTitleText:SetText(QTR_Messages[QTR_PS["lang"]].reward_title);
--      QuestInfoRewardsFrame.QuestSessionBonusReward:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
--      QuestInfoRewardsFrame.QuestSessionBonusReward:SetText(QTR_Messages[QTR_PS["lang"]].reward_bonus);
      if ( QuestInfoRewardsFrame:IsVisible() ) then
         for fontString in QuestInfoRewardsFrame.spellHeaderPool:EnumerateActive() do
            if (fontString:GetText() == REWARD_AURA) then
               fontString:SetText(QTR_Messages[QTR_PS["lang"]].reward_aura);
               fontString:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
            end
            if (fontString:GetText() == REWARD_SPELL) then
               fontString:SetText(QTR_Messages[QTR_PS["lang"]].reward_spell);
               fontString:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
            end
            if (fontString:GetText() == REWARD_COMPANION) then
               fontString:SetText(QTR_Messages[QTR_PS["lang"]].reward_companion);
               fontString:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
            end
            if (fontString:GetText() == REWARD_FOLLOWER) then
               fontString:SetText(QTR_Messages[QTR_PS["lang"]].reward_follower);
               fontString:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
            end
            if (fontString:GetText() == REWARD_REPUTATION) then
               fontString:SetText(QTR_Messages[QTR_PS["lang"]].reward_reputation);
               fontString:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
            end
            if (fontString:GetText() == REWARD_TITLE) then
               fontString:SetText(QTR_Messages[QTR_PS["lang"]].reward_title);
               fontString:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
            end
            if (fontString:GetText() == REWARD_TRADESKILL) then
               fontString:SetText(QTR_Messages[QTR_PS["lang"]].reward_tradeskill);
               fontString:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
            end
            if (fontString:GetText() == REWARD_UNLOCK) then
               fontString:SetText(QTR_Messages[QTR_PS["lang"]].reward_unlock);
               fontString:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
            end
            if (fontString:GetText() == REWARD_BONUS) then
               fontString:SetText(QTR_Messages[QTR_PS["lang"]].reward_bonus);
               fontString:SetFont(QTR_Font2[QTR_PS["lang"]], 13);
            end
         end
      end
--1      if ( MapQuestInfoRewardsFrame:IsVisible() ) then
--1         for fontString in MapQuestInfoRewardsFrame.spellHeaderPool:EnumerateActive() do
--1            if (fontString:GetText() == REWARD_AURA) then
--1               fontString:SetText(QTR_Messages[QTR_PS["lang"]].reward_aura);
--1               fontString:SetFont(QTR_Font2[QTR_PS["lang"]], 11);
--1            end
--1            if (fontString:GetText() == REWARD_SPELL) then
--1               fontString:SetText(QTR_Messages[QTR_PS["lang"]].reward_spell);
--1               fontString:SetFont(QTR_Font2[QTR_PS["lang"]], 11);
--1            end
--1            if (fontString:GetText() == REWARD_COMPANION) then
--1               fontString:SetText(QTR_Messages[QTR_PS["lang"]].reward_companion);
--1               fontString:SetFont(QTR_Font2[QTR_PS["lang"]], 11);
--1            end
--1            if (fontString:GetText() == REWARD_FOLLOWER) then
--1               fontString:SetText(QTR_Messages[QTR_PS["lang"]].reward_follower);
--1               fontString:SetFont(QTR_Font2[QTR_PS["lang"]], 11);
--1            end
--1            if (fontString:GetText() == REWARD_REPUTATION) then
--1               fontString:SetText(QTR_Messages[QTR_PS["lang"]].reward_reputation);
--1               fontString:SetFont(QTR_Font2[QTR_PS["lang"]], 11);
--1            end
--1            if (fontString:GetText() == REWARD_TITLE) then
--1               fontString:SetText(QTR_Messages[QTR_PS["lang"]].reward_title);
--1               fontString:SetFont(QTR_Font2[QTR_PS["lang"]], 11);
--1            end
--1            if (fontString:GetText() == REWARD_TRADESKILL) then
--1               fontString:SetText(QTR_Messages[QTR_PS["lang"]].reward_tradeskill);
--1               fontString:SetFont(QTR_Font2[QTR_PS["lang"]], 11);
--1            end
--1            if (fontString:GetText() == REWARD_UNLOCK) then
--1               fontString:SetText(QTR_Messages[QTR_PS["lang"]].reward_unlock);
--1               fontString:SetFont(QTR_Font2[QTR_PS["lang"]], 11);
--1            end
--1            if (fontString:GetText() == REWARD_BONUS) then
--1               fontString:SetText(QTR_Messages[QTR_PS["lang"]].reward_bonus);
--1               fontString:SetFont(QTR_Font2[QTR_PS["lang"]], 11);
--1            end
--1         end
--1      end
   else
      QuestInfoObjectivesHeader:SetFont(Original_Font1, 18);
      QuestInfoObjectivesHeader:SetText(QTR_MessOrig.objectives);
      QuestInfoRewardsFrame.Header:SetFont(Original_Font1, 18);
      QuestInfoRewardsFrame.Header:SetText(QTR_MessOrig.rewards);
      QuestInfoDescriptionHeader:SetFont(Original_Font1, 18);
      QuestInfoDescriptionHeader:SetText(QTR_MessOrig.details);
      QuestLogDescriptionTitle:SetFont(Original_Font1, 18);
      QuestLogDescriptionTitle:SetText(QTR_MessOrig.details);
      QuestLogRewardTitleText:SetFont(Original_Font1, 18);
      QuestLogRewardTitleText:SetText(QTR_MessOrig.rewards);
      QuestProgressRequiredItemsText:SetFont(Original_Font1, 18);
      QuestProgressRequiredItemsText:SetText(QTR_MessOrig.reqitems);
      CurrentQuestsText:SetFont(Original_Font1, 18);
      CurrentQuestsText:SetText(QTR_MessOrig.currquests);
      AvailableQuestsText:SetFont(Original_Font1, 18);
      AvailableQuestsText:SetText(QTR_MessOrig.avaiquests);
--      local regions = { QuestMapFrame.DetailsFrame.RewardsFrame:GetRegions() };
--      for index = 1, #regions do
--         local region = regions[index];
--         if ((region:GetObjectType() == "FontString") and (region:GetText() == QTR_Messages[QTR_PS["lang"]].rewards)) then
--            region:SetText(QUEST_REWARDS);
--         end
--      end
      
      -- stałe elementy okna zadania:
      QuestInfoRewardsFrame.ItemChooseText:SetFont(Original_Font2, 13);
      QuestInfoRewardsFrame.ItemReceiveText:SetFont(Original_Font2, 13);
      QuestInfoRewardsFrame.ItemChooseText:SetText(QTR_quest_EN[QTR_quest_ID].itemchoose);
      QuestInfoRewardsFrame.ItemReceiveText:SetText(QTR_quest_EN[QTR_quest_ID].itemreceive);
      QuestInfoSpellObjectiveLearnLabel:SetFont(Original_Font2, 13);
      QuestInfoSpellObjectiveLearnLabel:SetText(QTR_MessOrig.learnspell);
      QuestInfoXPFrame.ReceiveText:SetFont(Original_Font2, 13);
      QuestInfoXPFrame.ReceiveText:SetText(QTR_MessOrig.experience);
      QuestInfoRewardsFrame.XPFrame.ReceiveText:SetFont(Original_Font2, 13);
      QuestInfoRewardsFrame.XPFrame.ReceiveText:SetText(QTR_MessOrig.experience);
--1      MapQuestInfoRewardsFrame.ItemChooseText:SetFont(Original_Font2, 11);
--1      MapQuestInfoRewardsFrame.ItemReceiveText:SetFont(Original_Font2, 11);
--1      MapQuestInfoRewardsFrame.ItemChooseText:SetText(QTR_quest_EN[QTR_quest_ID].itemchoose);
--1      MapQuestInfoRewardsFrame.ItemReceiveText:SetText(QTR_quest_EN[QTR_quest_ID].itemreceive);
      QuestLogItemChooseText:SetFont(Original_Font2, 13);
      QuestLogItemChooseText:SetText(QTR_quest_EN[QTR_quest_ID].itemchoose);
      QuestInfoRewardsFrame.PlayerTitleText:SetFont(Original_Font2, 13);
      QuestInfoRewardsFrame.PlayerTitleText:SetText(QTR_MessOrig.reward_title);
--      QuestInfoRewardsFrame.QuestSessionBonusReward:SetFont(Original_Font2, 13);
--      QuestInfoRewardsFrame.QuestSessionBonusReward:SetText(QTR_MessOrig.reward_bonus);
      if ( QuestInfoRewardsFrame:IsVisible() ) then
         for fontString in QuestInfoRewardsFrame.spellHeaderPool:EnumerateActive() do
            if (fontString:GetText() == QTR_Messages[QTR_PS["lang"]].reward_aura) then
               fontString:SetText(REWARD_AURA);
               fontString:SetFont(Original_Font2, 13);
            end
            if (fontString:GetText() == QTR_Messages[QTR_PS["lang"]].reward_spell) then
               fontString:SetText(REWARD_SPELL);
               fontString:SetFont(Original_Font2, 13);
            end
            if (fontString:GetText() == QTR_Messages[QTR_PS["lang"]].reward_companion) then
               fontString:SetText(REWARD_COMPANION);
               fontString:SetFont(Original_Font2, 13);
            end
            if (fontString:GetText() == QTR_Messages[QTR_PS["lang"]].reward_follower) then
               fontString:SetText(REWARD_FOLLOWER);
               fontString:SetFont(Original_Font2, 13);
            end
            if (fontString:GetText() == QTR_Messages[QTR_PS["lang"]].reward_reputation) then
               fontString:SetText(REWARD_REPUTATION);
               fontString:SetFont(Original_Font2, 13);
            end
            if (fontString:GetText() == QTR_Messages[QTR_PS["lang"]].reward_title) then
               fontString:SetText(REWARD_TITLE);
               fontString:SetFont(Original_Font2, 13);
            end
            if (fontString:GetText() == QTR_Messages[QTR_PS["lang"]].reward_tradeskill) then
               fontString:SetText(REWARD_TRADESKILL);
               fontString:SetFont(Original_Font2, 13);
            end
            if (fontString:GetText() == QTR_Messages[QTR_PS["lang"]].reward_unlock) then
               fontString:SetText(REWARD_UNLOCK);
               fontString:SetFont(Original_Font2, 13);
            end
            if (fontString:GetText() == QTR_Messages[QTR_PS["lang"]].reward_bonus) then
               fontString:SetText(REWARD_BONUS);
               fontString:SetFont(Original_Font2, 13);
            end
         end
      end
--1      if ( MapQuestInfoRewardsFrame:IsVisible() ) then
--1         for fontString in MapQuestInfoRewardsFrame.spellHeaderPool:EnumerateActive() do
--1            if (fontString:GetText() == QTR_Messages[QTR_PS["lang"]].reward_aura) then
--1               fontString:SetText(REWARD_AURA);
--1               fontString:SetFont(Original_Font2, 11);
--1            end
--1            if (fontString:GetText() == QTR_Messages[QTR_PS["lang"]].reward_spell) then
--1               fontString:SetText(REWARD_SPELL);
--1               fontString:SetFont(Original_Font2, 11);
--1            end
--1            if (fontString:GetText() == QTR_Messages[QTR_PS["lang"]].reward_companion) then
--1               fontString:SetText(REWARD_COMPANION);
--1               fontString:SetFont(Original_Font2, 11);
--1            end
--1            if (fontString:GetText() == QTR_Messages[QTR_PS["lang"]].reward_follower) then
--1               fontString:SetText(REWARD_FOLLOWER);
--1               fontString:SetFont(Original_Font2, 11);
--1            end
--1            if (fontString:GetText() == QTR_Messages[QTR_PS["lang"]].reward_reputation) then
--1               fontString:SetText(REWARD_REPUTATION);
--1               fontString:SetFont(Original_Font2, 11);
--1            end
--1            if (fontString:GetText() == QTR_Messages[QTR_PS["lang"]].reward_title) then
--1               fontString:SetText(REWARD_TITLE);
--1               fontString:SetFont(Original_Font2, 11);
--1            end
--1            if (fontString:GetText() == QTR_Messages[QTR_PS["lang"]].reward_tradeskill) then
--1               fontString:SetText(REWARD_TRADESKILL);
--1               fontString:SetFont(Original_Font2, 11);
--1            end
--1            if (fontString:GetText() == QTR_Messages[QTR_PS["lang"]].reward_unlock) then
--1               fontString:SetText(REWARD_UNLOCK);
--1               fontString:SetFont(Original_Font2, 11);
--1            end
--1            if (fontString:GetText() == QTR_Messages[QTR_PS["lang"]].reward_bonus) then
--1               fontString:SetText(REWARD_BONUS);
--1               fontString:SetFont(Original_Font2, 11);
--1            end
--1         end
--1      end
   end
end


function QTR_delayed3()
   QTR_ToggleButton4:SetText("wybierz wpierw quest");
   QTR_ToggleButton4:Hide();
   if (not QTR_wait(1,QTR_delayed4)) then
   ---
   end
end


function QTR_delayed4()
   QTR_QuestPrepare('');
end;      


function QTR_PrepareDelay(czas)     -- wywoływane po kliknięciu na nazwę questu z listy NPC
   if (czas==1) then
      if (not QTR_wait(1,QTR_PrepareReload)) then
      ---
      end
   end
   if (czas==3) then
      if (not QTR_wait(3,QTR_PrepareReload)) then
      ---
      end
   end
end;      


function QTR_PrepareReload()
   QTR_QuestPrepare('');
end;      


-- podmieniaj specjane znaki w tekście
function QTR_ExpandUnitInfo(msg)
   msg = string.gsub(msg, "$B", "\n");
   msg = string.gsub(msg, "$N", QTR_name);

   msg = string.gsub(msg, "$C", player_class);        
   msg = string.gsub(msg, "$R", player_race);          
   
-- jeszcze obsłużyć YOUR_GENDER(x;y)   - polskie tłumaczenia
   local nr_1, nr_2, nr_3 = 0;
   local QTR_forma = "";
   local nr_poz = string.find(msg, "YOUR_GENDER");    -- gdy nie znalazł, jest: nil
   while (nr_poz and nr_poz>0) do
      nr_1 = nr_poz + 1;   
      while (string.sub(msg, nr_1, nr_1) ~= "(") do
         nr_1 = nr_1 + 1;
      end
      if (string.sub(msg, nr_1, nr_1) == "(") then
         nr_2 =  nr_1 + 1;
         while (string.sub(msg, nr_2, nr_2) ~= ";") do
            nr_2 = nr_2 + 1;
         end
         if (string.sub(msg, nr_2, nr_2) == ";") then
            nr_3 = nr_2 + 1;
            while (string.sub(msg, nr_3, nr_3) ~= ")") do
               nr_3 = nr_3 + 1;
            end
            if (string.sub(msg, nr_3, nr_3) == ")") then
               if (QTR_sex==3) then        -- forma żeńska
                  QTR_forma = string.sub(msg,nr_2+1,nr_3-1);
               else                        -- forma męska
                  QTR_forma = string.sub(msg,nr_1+1,nr_2-1);
               end
               msg = string.sub(msg,1,nr_poz-1) .. QTR_forma .. string.sub(msg,nr_3+1);
            end   
         end
      end
      nr_poz = string.find(msg, "YOUR_GENDER");
   end

-- jeszcze obsłużyć $Gx:y;   - tłumaczenia inne
   local nr_1, nr_2, nr_3 = 0;
   local QTR_forma = "";
   local nr_poz = string.find(msg, "$G");    -- gdy nie znalazł, jest: nil
   while (nr_poz and nr_poz>0) do
      nr_1 = nr_poz + 1;   
      nr_2 =  nr_1 + 1;
      while (string.sub(msg, nr_2, nr_2) ~= ":") do   -- separator formy męski:żeński
         nr_2 = nr_2 + 1;
      end
      if (string.sub(msg, nr_2, nr_2) == ":") then
         nr_3 = nr_2 + 1;
         while (string.sub(msg, nr_3, nr_3) ~= ";") do   -- koniec formy żeńskiej
            nr_3 = nr_3 + 1;
         end
         if (string.sub(msg, nr_3, nr_3) == ";") then
            if (QTR_sex==3) then        -- forma żeńska
               QTR_forma = string.sub(msg,nr_2+1,nr_3-1);
            else                        -- forma męska
               QTR_forma = string.sub(msg,nr_1+1,nr_2-1);
            end
            msg = string.sub(msg,1,nr_poz-1) .. QTR_forma .. string.sub(msg,nr_3+1);
         end
      end
      nr_poz = string.find(msg, "$G");
   end

   return msg;
end


QTR = CreateFrame("Frame");
QTR:SetScript("OnEvent", QTR_OnEvent);
QTR:RegisterEvent("ADDON_LOADED");
